
from Twistpot import TwistPot
from math import pi, sqrt, acos
from vec3 import norm , Vec3, unitVec, dot, cross
from atomSelAction import Fit
from math import cos, sin, atan2
import xplor


def calcStrandTwist(resids):
    """Calculates twist for each 4 residue window in a strand
       and its sum
       calcStrandTwist([140, 150])
    """
    
    rest=[]
    nframes=0.
    for res in range(resids[0], (resids[1]+1)-3):
        nframes +=1.
        rest.append([ 'resid %i and name CA' %(res), 'resid %i and name CA' %(res+1), 'resid %i and name CA' %(res+2), 'resid %i and name CA' %(res+3),  0.0])
        
    twist=TwistPot('twistdummy', rest)
    twist.setScale(1000.)
    
    overall_twist=0.0
    print '# Selection_1      Selection_2      Selection_3      Selection_4    Dihedral     Norm_Dihedral'
    for r in twist.restraints():
        dih_in_deg=r.value()*(180./pi)
        
        # normalise so trans state is 0 deg
        if dih_in_deg<0:
            twist_angle=dih_in_deg+180.
        elif dih_in_deg>0:
            twist_angle=dih_in_deg-180.
        
        print '%s %.3f  %.3f' %(r.string(), dih_in_deg, twist_angle )
        overall_twist +=twist_angle/nframes
    
    return overall_twist

def calcStrandAngle(start1, end1, start2, end2):
    from atomSel import AtomSel
    """Calculates angle between strands
    """
    
    vector1= AtomSel(start1)[0].pos() -AtomSel(end1)[0].pos()
    vector2= AtomSel(start2)[0].pos() -AtomSel(end2)[0].pos()


    cos_theta=dot(vector1, vector2) / (norm(vector1)* norm(vector2) )
    
    return acos( cos_theta )/(pi/180.0)
        


